/** @file AnalogOutputWrite1Value.c
 * 
 * AnalogOutputWrite1Value: Analog output write 1 value sample
 *
 * @author C. Guinot
 * @date 30.01.2007
 * 
 * @version $LastChangedRevision$
 * @version $LastChangedDate$
 * 
 * 
 * @par LICENCE
 * @par LICENCE
 * @verbatim
 *  Copyright (C) 2004,2005  ADDI-DATA GmbH for the source code of this module.
 *        
 *        ADDI-DATA GmbH 
 *        Airport Boulevard B210
 *        D-77836 Rheinmnster Germany 
 *        Tel: +49(0)7229/1847-0 
 *        Fax: +49(0)7229/1847-200
 *        http://www.addi-data-com 
 *        info@addi-data.com 
 *        
 *
 * @endverbatim   
 *
 * @par UPDATES                                                                                                          
 * @verbatim                                                                                                             
 *                                                                                                                       
 *  Date      : 
 *  Author        : 
 *  Description   : 
 *
 * @endverbatim     
 */ 

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>


#include "..\..\..\..\Interface_Library\MSXE351x.nsmap"
#include "..\utility.h"


#define SOAP_ACTION ""


//-------------------------------------------------------------------------------------------------------

/** Write one channel value.
 * 
 * @retval 0:	No error.
 * @retval 1:	Error.
 */
int i_SAMPLE_WriteChannelValue (struct soap *ps_SoapEnv, unsigned char *pc_SOAPIPAddress, unsigned long dw_NbrOfChannel)
{
	struct MSXE351x__Response Response;
    struct MSXE351x__AnalogOutputGetStatusResponse StatusResponse;
	int i_Error = 0;
	unsigned long  ulChannel = 0;
    unsigned long  ulOutputType = 0;
    unsigned long  ulPolarity = 0;
    unsigned long  ulTriggerMask = 0;
    unsigned long  ulTriggerEdgeSelection = 0;
    unsigned long  ulTriggerCount =0;
	unsigned long  ulChannelValue = 0x7FFF;
    unsigned long  ulContinue = 0;
	int ret = 0;

		Response.iReturnValue = 0;
        StatusResponse.sResponse.iReturnValue = 0;
	
		printf ("\n");	

        do
        {
            printf("\n Do You want to write another value ? (0: No, 1 : Yes) :");
            scanf("%lu",&ulContinue);
        }
        while (ulContinue> 1);

        if (ulContinue)
        {


            do
            {
                printf("\nEnter the channel do You want to write to (0 to %d) :",dw_NbrOfChannel-1);
                scanf ("%d",&ulChannel);
            }
            while (ulChannel >= dw_NbrOfChannel);
            do
            {
                printf("\nEnter the channel configuration do You want to use (0:Voltage, 1:Current) :");
                scanf ("%d",&ulOutputType);
            }
            while (ulOutputType > 1);
            do
            {
                printf("\nEnter the channel polarity do You want to use (0:Unipolar, 1:Bipolar) :");
                scanf ("%d",&ulPolarity);
            }
            while (ulPolarity > 1);
            do
            {
                printf("\nDo You want to use an extern trigger ? (0:no trigger use, 1:Digital Input Trigger, 2:Synchro Trigger) :");
                scanf ("%d",&ulTriggerMask);
            }
            while (ulTriggerMask > 2);

            if (ulTriggerMask == 1)
            {
                do
                {
                    printf("\nSelect the edge to react for the digital input trigger (1:rising edge, 2:falling edge, 3:both edge) :");
                    scanf ("%d",&ulTriggerEdgeSelection);
                }
                while ((ulTriggerEdgeSelection == 0) ||(ulTriggerEdgeSelection > 3));
                do
                {
                    printf("\nSelect the digital input trigger count value (min 1):");
                    scanf ("%d",&ulTriggerCount);
                }
                while (ulTriggerCount == 0);

            }

            do
            {
                if (ulPolarity == 0)
                    printf("\nEnter the output value to write in Hex (0 to 0x7FFF) : 0x");
                else
                    printf("\nEnter the output value to write in Hex (0 to 0xFFFF) : 0x");
                scanf ("%lX",&ulChannelValue);
            }
            while (((ulChannelValue > 0x7FFF) && (ulPolarity == 0)) || ((ulChannelValue > 0xFFFF) && (ulPolarity == 1)));
				    
		    i_Error = soap_call_MSXE351x__AnalogOutputWrite1Value  (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION,ulChannel,ulOutputType,ulPolarity, 
                                                                    ulTriggerMask,ulTriggerEdgeSelection,ulTriggerCount,ulChannelValue,0,0,0,&Response);

		    if ((i_Error == 0) && (Response.iReturnValue == 0))
		    {			
                if (ulTriggerMask == 0)
			        printf ("Write %lu on channel %lu\n", ulChannelValue, ulChannel);			
                else
                {
                    printf("\n The output value wait for a trigger ! Press ESC to abort...");

                    for(;;) 
                    {
                        i_Error = soap_call_MSXE351x__AnalogOutputGetStatus(ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION,0,&StatusResponse);
                        if ((i_Error == 0) && (StatusResponse.sResponse.iReturnValue == 0))
                        {
                            if (StatusResponse.ulStatus == 0)
                            {
                                printf("\n The trigger occur, the output is ready to receive another value");
                                ret = 0;
								goto error;
                            }
                            else
                            {
	                            if (kbhit()) 
				                {
					                if (getch() == 27)
									{
						                ret = 1;
										goto error;
									}
				                }					
                            }

                        
                        }
                        else
                        {
                            printf("soap_call_MSXE351x__AnalogOutputGetStatus SOAP error: %d, Response error: %d\n",i_Error,StatusResponse.sResponse.iReturnValue);
	                        if (i_Error != 0)
	                            printf("SOAP Error : %s\n",*soap_faultstring(ps_SoapEnv));

			                ret = 1;
							goto error;	
                        }

                    }

                }
		    } 
		    else
		    {
			    printf("soap_call_MSXE351x__AnalogOutputWrite1Value SOAP error: %d, Response error: %d\n",i_Error,Response.iReturnValue);
	            if (i_Error != 0)
	                printf("SOAP Error : %s\n",*soap_faultstring(ps_SoapEnv));

				ret = 1;
				goto error;	
		    }
        }
        else
        {
			ret = 1;
        }

error:
		/* 
		 * gSOAP doesn't release automatically the memory that 
		 * it allocates to deserialize data, that's why both 
		 * following functions have to be used to release the 
		 * allocated memory.
		 */
		soap_destroy(ps_SoapEnv);
		soap_end(ps_SoapEnv);
	
		return ret;
}

//-------------------------------------------------------------------------------------------------------

void main(void)
{
	int i_Error = 0;
	struct soap *ps_SoapEnv = NULL;
	struct MXCommon__ByteArrayResponse  s_ByteArrayResponse;
	unsigned char pc_IPAddressTemp[50];
	unsigned char pc_IPAddress[50];
	unsigned char pc_SOAPIPAddress[50];
	unsigned long dw_Dummy = 0;
	unsigned long dw_NbrOfChannel = 8;

	/* Print sample information */
	printf("+---------------------------------------------------+\n");
	printf("| MSX-E351x                                         |\n");
 	printf("| Analog output write 1 value sample                |\n"); 
 	printf("+---------------------------------------------------+\n");
	printf("\n");

	/* Initialise the SOAP connection */
	if (i_SOAP_Init(&ps_SoapEnv) == 0)
	{
		/* Get the IP address */
		printf("Enter the module IP Address (XXX.XXX.XXX.XXX): ");
		gets(pc_IPAddressTemp);

		/* Format and set the IP address */
		v_UTILS_ClearNullInIPAddress(pc_IPAddressTemp,pc_IPAddress);
		sprintf(pc_SOAPIPAddress,"%s:5555", pc_IPAddress);
		printf("\nSOAP IP Address: %s\n", pc_SOAPIPAddress);

		/* Get the module type */
		i_Error = soap_call_MXCommon__GetModuleType(ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, &dw_Dummy, &s_ByteArrayResponse);
		if ((i_Error == 0) && (s_ByteArrayResponse.sResponse.iReturnValue == 0))
		{
			printf("Module Type: %s\n", s_ByteArrayResponse.sArray.__ptr);


			for ( ; ; )
			{
				
                if (i_SAMPLE_WriteChannelValue (ps_SoapEnv, pc_SOAPIPAddress, dw_NbrOfChannel))
                    break;

				if (kbhit()) 
				{
					if (getch() == 27)
						break;
				}					
			}


		}
		else
		{
			printf("soap_call_MXCommon__GetModuleType SOAP error: %d, Response error :%d\n", i_Error,s_ByteArrayResponse.sResponse.iReturnValue);
            if (i_Error != 0)
                 printf("SOAP Error : %s\n",*soap_faultstring(ps_SoapEnv));
		}

		/* Close the SOAP connection */
		i_SOAP_Close (ps_SoapEnv);
	}

	/* Print End programme informations */
	printf("\n\n");
	printf("+---------------------------------------------------+\n");
	printf("| Program stopped                                   |\n");
	printf("+---------------------------------------------------+\n");
	printf("| Press any key to exit from sample                 |\n");
	printf("+---------------------------------------------------+\n");

	while (!(kbhit()));
}
