

#ifndef __SAMPLE_UTILITY_H_
	#define __SAMPLE_UTILITY_H_

//-------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------

/** Display a timeval struct in human string
 *
 * Convert and save date and time element
 * of a timeval struct in comprehensible outputs:
 * day/month/years hour:min.:sec.:msec.:usec.
 */
void DisplayTimeStamp (DWORD TimeStampLow, DWORD TimeStampHigh)
{
	struct tm *tm_ptr;
	time_t useconds, mseconds;
       
       tm_ptr = localtime (&TimeStampHigh);
       useconds = TimeStampLow;       
       mseconds = useconds/1000;
       useconds -= (mseconds * 1000);
       printf ("%02d/%02d/%04d-%02d:%02d:%02d:%03ld:%03ld", tm_ptr->tm_mday, (tm_ptr->tm_mon+1), (tm_ptr->tm_year + 1900), tm_ptr->tm_hour, tm_ptr->tm_min, tm_ptr->tm_sec, mseconds, useconds);
}

//-------------------------------------------------------------------------------------------------------
//										Utility functions
//-------------------------------------------------------------------------------------------------------

/** Format the IP address.
 *
 * @param [in]	pc_IPAddress	: The IP address in string form.
 * @param [out]	pc_NewIPAddress	: The formatted IP address in string form.
 */
static VOID v_UTILS_ClearNullInIPAddress(PCHAR pc_IPAddress, PCHAR pc_NewIPAddress)
{
	unsigned char b_Cpt = 0;
	unsigned char b_Index = 0;
	unsigned char b_ClearNullFlag = 1;
	unsigned char b_IPIsNull = 1;

	while (pc_IPAddress[b_Cpt] != '\0')
	{
		if (pc_IPAddress[b_Cpt] == '.')
		{
			if (b_IPIsNull)
				pc_NewIPAddress[b_Index++] = '0';

			pc_NewIPAddress[b_Index++] = pc_IPAddress[b_Cpt];
			b_ClearNullFlag = 1;
			b_IPIsNull = 1;
		}
		else
	    {
			if ((pc_IPAddress[b_Cpt] == '0') && (b_ClearNullFlag == 0))
			{
				pc_NewIPAddress[b_Index++] = pc_IPAddress[b_Cpt];
			}
		
			if (pc_IPAddress[b_Cpt] != '0') 
			{
				pc_NewIPAddress[b_Index++] = pc_IPAddress[b_Cpt];
				b_ClearNullFlag = 0;
				b_IPIsNull = 0;
			}
		}
		b_Cpt ++;
	}
	pc_NewIPAddress[b_Index] = '\0';
}

//-------------------------------------------------------------------------------------------------------
//                                       SOAP function                                                             
//-------------------------------------------------------------------------------------------------------

#define SOAP_ACTION ""

static int i_SOAP_Init(struct soap **ps_SoapEnv)
{
	/* Initialise the SOAP connection */
	*ps_SoapEnv = soap_new();

	if (*ps_SoapEnv != NULL)
	{
		soap_init2(*ps_SoapEnv, SOAP_IO_KEEPALIVE, SOAP_IO_KEEPALIVE);
		(*ps_SoapEnv) -> send_timeout = 1;
		(*ps_SoapEnv) -> recv_timeout = 1;
		(*ps_SoapEnv) -> accept_timeout = 1;
		return 0;
	}
	printf ("Fail to initialize the SOAP connection\n");
	return -1;
}

//-------------------------------------------------------------------------------------------------------

static int i_SOAP_Close(struct soap *ps_SoapEnv)
{
	soap_destroy(ps_SoapEnv);
	soap_end(ps_SoapEnv);
	soap_free(ps_SoapEnv);
	return 0;
}

//-------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------

#endif // #ifndef __SAMPLE_UTILITY_H_